/**
 ** .jsx for Adobe apps. Marat Shagiev. JetBrains WebStorm. 06.01.13
 **/

/** ,   
 *        jpeg;
 *     ;
 *      - */

//#target illustrator;

/******************
 *** THE SCRIPT ***
 ******************/

makeInterface();

/**
 *  
 * */
function makeInterface() {

  var numbOfJpegs = +prompt('   ?', '3');
  var exportOpts = {}; //          
  var dialObj = new Dialog(); //       (   )
  var dialWin = dialObj.makeCarcass(); //   -  
  var saveVisible = getVisible(dialObj); //    ,      
  /**
   *    numbOfJpegs  (, ?)   
   * (      )
   *     - setVisible, expToJpg  setResolution   exportOpts
   **/
  for (var i = 0; i < numbOfJpegs; i++) {
    //  addExportSet   
    //    exportOpts
    exportOpts['set' + i] = dialObj.addExportSet(dialWin.children[0]);
  }
//     'export'
  dialWin.children[1].children[0].onClick = function f() {
    //  ,  ,      
    makeDir(dialObj, 'jpg');

    for (var j = 0; j < numbOfJpegs; j++) {
      if (exportOpts['set' + j].activateCheck.value) {
        setVisible(exportOpts['set' + j], dialObj);
        expToJpg(exportOpts['set' + j], dialObj);
        setResolution(exportOpts['set' + j], dialObj);
      }
    }
    setVisible(saveVisible, dialObj); //     
    dialWin.close(); //    'export'  
  }
  dialObj.showDialog(dialWin);
}

/*********************
 *** THE INTERFACE ***
 *********************/

/**
 *  
 * */
function Dialog() {

  var self = this;
  self.k = 1.388888888; // Image scaling factor (100/72)
  self.laysNames = getLaysNames();
  self.lays = getAllLays();
  self.doc = app.activeDocument;

  /**
   * @return {Window}  -
   * */
  self.makeCarcass = function f() {

    var dialogWin = new Window("dialog", "export to jpg");

    //===== STRUCTURE =====
    var setsGroup = dialogWin.add('group');
    var buttGroup = dialogWin.add('group');

    var exportButt = buttGroup.add("button", undefined, "export");
    var closeButt = buttGroup.add("button", undefined, "exit");

    //===== FORMAT ======
    setsGroup.orientation = 'column';

    //===== HENDLERS =====
    closeButt.onClick = function f() {
      dialogWin.close();
    }
    return dialogWin;
  }

  /**
   *   container ui-   
   * @param {container} ui--
   * @return {Object}      ui-   
   * */
  self.addExportSet = function(container) {
    var o = {};
    //===== STRUCTURE =====
    o.set = container.add('group');

    o.opts = o.set.add('group'); //  
    o.lays = o.set.add('group'); //   

    // 4    
    o.activateSetGroup = o.opts.add('group'); // , / 
    o.qualGroup = o.opts.add('group'); //   jpg
    o.cropAndResGroup = o.opts.add('group'); //      (     )
    o.suffixGroup = o.opts.add('group'); //  _txt  _W

    // , / 
    o.activateCheck = o.activateSetGroup.add('checkbox');
    o.activateSetGroupText = o.activateSetGroup.add('statictext', undefined, 'activate');

    //   jpg
    o.gualGroupText = o.qualGroup.add('statictext', undefined, 'quality');
    o.qualGroupVal = o.qualGroup.add('edittext {text: 8, characters:3, justify:"center"}');
    o.qualGroupSlider = o.qualGroup.add('slider', undefined, 8, 0, 10);

    //      (     )
    o.resVal = o.cropAndResGroup.add('dropdownlist', undefined, [72, 150, 200, 250, 300]);
    o.crop = o.cropAndResGroup.add('checkbox', undefined, 'crop to artoard');

    //   
    o.laysList = o.lays.add("listbox", undefined, undefined, {multiselect:true});
    for (var i = 0; i < getLaysNames().length; i++) {
      o.laysList.add("item", getLaysNames()[i]);
    }

    //===== START VALUES =====
    o.activateCheck.value = true;
    o.resVal.selection = 2;
    o.resVal.text = 'resolution';

    //===== FORMAT ======
    o.opts.orientation = 'column';
    o.opts.alignChildren = 'fill';

    //===== HENDLERS ======
    /**
     *     () 
     * */
    o.qualGroup.addEventListener('changing', function(e) {
      var targ = e.target;
      if (targ.text) {
        targ.parent.children[2].value = targ.text;
      } else if (targ.value) {
        targ.parent.children[1].text = Math.round(targ.parent.children[2].value);
      }
    })
    return o;
  }

  self.showDialog = function f(win) {
    win.show();
  }
}

/*********************
 **  THE LIBRARY
 *********************/

/**  TODO:    ,    '==='
 *  -  visible = true/false
 * @param {Array}  ,  visible = true,  visible = false
 * @return {number} 1,     -1,    
 */
function setVisible(o, w) {
  // var lays = app.activeDocument.layers;
  var lays = w.lays;
  var arrNames = o.laysList.selection;
  outer:
    for (var i = 0; i < lays.length; i++) { //    

      for (var j = 0; j < arrNames.length; j++) { //      
        if (lays[i].name != arrNames[j].text)  //   
          continue; //  
        lays[i].visible = true; //    
        continue outer //    
      }
      //    ,
      //          =>   
      lays[i].visible = false;
      //    
    }
}

/**
 *   
 * @return {Object}     UI listbox
 * */
function getVisible(w) {
  var lays = w.lays;
  var visibleLays = {};
  visibleLays.laysList = {};
  visibleLays.laysList.selection = [];

  var j = 0;
  for (var i = 0; i < lays.length; i++) {
    if (lays[i].visible == true) {
      visibleLays.laysList.selection.push({text:''});
      visibleLays.laysList.selection[j].text = lays[i].name;
      j++;
    }
  }
  return  visibleLays;
}

/**
 *   jpg
 */
function expToJpg(o, w) {
  var props = new ExportOptionsJPEG();
  var type = ExportType.JPEG;
  var fullPath = w.doc.path.fullName + '../../' + 'jpg' +
    '/' + w.doc.name.slice(0, -3) + '_' + o.laysList.selection[0].text + '.jpg';

  var f = new File(fullPath);

  props.qualitySetting = o.qualGroupVal.text * 10;
  props.horizontalScale = props.verticalScale = o.resVal.selection.text * w.k;
  props.artBoardClipping = o.crop.value;

  w.doc.exportFile(f, type, props);
}

/**
 *    -
 */
function setResolution(o, w) {

  var fullPath = w.doc.path.fullName + '../../' + 'jpg' + '/' + w.doc.name.slice(0, -3) + '_' +
    spaceOnDash(o.laysList.selection[0].text) + //           (?!!)
    '.jpg';
  var res = o.resVal.selection.text

  photoshop.executeScript(
    "" +
      "startDisplayDialogs = displayDialogs; " +
      "startRulerUnits = preferences.rulerUnits;" +
      "startTypeUnits = preferences.typeUnits;" +
      "preferences.rulerUnits = Units.PIXELS; " +
      "displayDialogs = DialogModes.NO;" +
      "var f = new File('" + fullPath + "'); " +
      "open(f);" +
      "activeDocument.resizeImage(activeDocument.width, activeDocument.height," + res + ", ResampleMethod.BICUBIC);" +
      "displayDialogs = startDisplayDialogs;" +
      "preferences.rulerUnits = startRulerUnits;" +
      "preferences.typeUnits = startTypeUnits;" +
      "activeDocument.save();" +
      "activeDocument.close();"
  )
}

/**
 * @return {Folder}  Folder
 * */
function makeDir(w, dirName) { // make dir., witch parallel to the current dir. (current is 'activeDocument.path')
  var dirPath = w.doc.path.fullName + '../../' + dirName; // full path of the creating directory
  var dir = new Folder(dirPath); // calling Folder constructor
  dir.create(); // creating directory by Folder constructor method 'create()'
  return dir;
}

/**
 * @return {Document.layers}   layers
 * */
function getAllLays(doc) {
  doc = doc || activeDocument;
  var lays = doc.layers;
  return lays;
}

/**
 * @return {array}    
 * */
function getLaysNames(doc, lays) {
  doc = doc || activeDocument;
  lays = lays || doc.layers;
  var arrNames = [];
  for (var i = 0; i < lays.length; i++) {
    arrNames.push(lays[i].name);
  }
  return arrNames;
}

/**
 *   str     
 */
function spaceOnDash(str) {
  var newStr = '';
  for (var l = 0; l < str.length; l++) {
    (str.charAt(l) == ' ') ? newStr += '-' : newStr += str[l];
  }
  return newStr;
}